/*
 * LoadStat.hpp
 *
 */
#ifndef LOAD_STAT_HPP
#define LOAD_STAT_HPP

#include "Util.hpp"
class LoadStat {
public:
  static float maxWorkspaceSizeInMB;
  static float totalDPIterationCountInMT;
  static int dpCount;
  static bool accountForWidth;
  static Vector<int> lengths;
  static Vector<int> stripWidths;
  static Vector<float> vScore;
  static ostringstream os;
  
  static void addStripWidth(int stripWidth);
  static void addLengths(int lengthX, int lengthY);
  static void addLengths(int lenX, int lenY, int stripWidth);
  static void setAccountForWidth(bool flag);
  static void incrementDPCount();
  static void addWorkspaceSize(float workspaceSizeInMB);
  static void addDPIterationCount(float dpIterationCountInMT);
  static int getMemUse();
  static float getMemUseInMB();
  static void printMemUse(ostream& fo = cout, int indentLevel = 0);
  static void printElapsedTime(ostream& fo = cout, int indentLevel = 0);
  static int getElapsedTimeInSec();
  static void printReport(ostream& fo = cout);
  static string toYAMLString();
  static void mergeYAMLString(const string& str);
  static string toString();
  static void print();
};

#endif
