/*
 * DPDeckPSCFGDPLocalsTest.cpp
 *
 */
#ifndef DP_DECK_PSCFG_DP_LOCALS_TEST_CPP
#define DP_DECK_PSCFG_DP_LOCALS_TEST_CPP
#include "DPDeckPSCFGDPLocals.hpp"
#include "DPDeckPSCFGDPTask.hpp"
#include "DPDeckPSCFGVectors.hpp"

#define TEMPLATE template <typename Task>
#define CLASS DPDeckPSCFG::DPLocals<Task>
//#define TEMPLATE
//#define CLASS DPDeckPSCFG::DPLocals

TEMPLATE
Rect
CLASS::
getCurrRect() const
{
  Rect rect;
  rect.bx = vx.getPos(bx);
  rect.by = vy.getPos(by);
  rect.ex = vx.getPos(ex);
  rect.ey = vy.getPos(ey);
  return rect;
}
TEMPLATE
void
CLASS::
testInitialState() const
{

}
TEMPLATE
void
CLASS::
testFinalState() const
{
#ifdef DEBUG
  Assert(!dpi.getNext());
  Assert(bx == bx_lim);
  Assert(ex == ex_lim);
  Rect rect = getCurrRect();
  const ScoreManager::SCNode& sc = *curr_sc;
  if (Task::isSmallCYK()) {
    if (Task::storeB()) {
      if (Task::isInsideType()) {
	Assert((scb_store-1) == &vsfbwB.tail(region));
      } else {
	Assert((scb_store+1) == &vsfbwB.head(region));
      }
    }
    if (Task::storeE()) {
      if (Task::isInsideType()) {
	Assert((sce_store-1) == &vsfbwE.tail(region));
      } else {
	Assert((sce_store+1) == &vsfbwE.head(region));
      }
    }
  } else if (Task::isCYK()) {
    Assert((tau-1) == &vtb.tail(region));
    //if (rect == dpRegion.rect0) {
    //  if (!dpDeck.dpAlongPath || rect == dpRegion.rect0) {
    //	Assert(IsFinite(sc[Model::ST_st]));
    //	Assert((tau-1)->isAltered());
    //  }
    //}

    Model::Iterator it;
    while (it.getNext()) {
      const State s = it.s;
      if (IsFinite(sc[s])) {
	if (!(rect.b == rect.e)
	    && !dpTask.isLeftChild(rect, s)
	    && !dpTask.isRightChild(rect, s)) {

	  const Rect rect1 = model.addNEmit(rect, s);
	  Assert(region.includes(rect1));
	  const TBNode& tbn = dpDeck.vtb.ref(region, rect);

	  if (model.bifurcates(s)) {

	  } else {
	    Assert(tbn.valIsSet(s));
	    const State s1 = tbn.getVal(s);
	    Assert(model.isChild(s, s1));
	  }

	  const Vector<TBTree::Link>& treeNodes = 
	  dpTask.traceback(rect, s);
	  Vector<State> states1(dpTask.getStates());
	  states1[0] = s;
	  TBTree tbTree(treeNodes, states1);
	  //tbTree.print();
	  treeNodes[0]->testConsistencyR();
	  const DPScoreT score1 =
	    dpDeck.computeScoreFromTree(tbTree, states1);
	  Assert(abs(score1 - sc[s]) <= 0.1*(1.0+abs(score1)+abs(sc[s])),
		 "score1=%f, sc[%s]=%f",
		 (float)score1, model.state2str(s), (float)sc[s]);
	}
      }
    }

    if (region.getVSTSize() > 0) {
      Assert((tau_BF-1) == &vtbbf.tail(region));
    }
  } else if (Task::isInside()) {
    Assert((sce_store-1) == &vfw.tail(region));
    //Assert(IsFinite(sc[Model::ST_st]));
  } else if (Task::isOutside()) {
    Assert((sce_store+1) == &vbw.head(region));
  }
#endif
}
TEMPLATE
void
CLASS::
testDPProcInitialState() const
{
#ifdef DEBUG
  const StateFlags& T = stateFlags;

  const Rect rect = getCurrRect();
  Assert(region.includes(rect));
  Assert(dpi.getNext());
  Assert(dpi.rect == rect);
  EscVec Esc0(scoreManager, vx, vy, vpairX, vpairY);
  TscVec Tsc0(scoreManager, vx, vy, vpairX, vpairY);
  //ScoreManager::Esc Esc0(scoreManager);
  //ScoreManager::Tsc Esc0(scoreManager);
    
  if (Task::insideType) {
    if (rect.bx < rect.ex - 1) {
      Assert(pairX == &vpairX.ref(rect.bx, rect.ex - 1),
	     "pairX - &vpair.ref(%d,%d)=%d",
	     rect.bx, rect.ex - 1,
	     (pairX - &vpairX.ref(rect.bx, rect.ex - 1)));
    }
    if (rect.bx + 1 < rect.ex - 1) {
      Assert(prev_pairX == &vpairX.ref(rect.bx + 1, rect.ex - 1),
	     "prev_pairX - &vpair.ref(%d,%d)=%d",
	     rect.bx + 1, rect.ex - 1,
	     (prev_pairX - &vpairX.ref(rect.bx + 1, rect.ex - 1)));
    }
  } else {
    if (rect.bx - 1 < rect.ex) {
      Assert(pairX == &vpairX.ref(rect.bx - 1, rect.ex),
	     "pairX - &vpair.ref(%d,%d)=%d",
	     rect.bx - 1, rect.ex,
	     (pairX - &vpairX.ref(rect.bx - 1, rect.ex)));
    }
    if (rect.bx < rect.ex) {
      Assert(prev_pairX == &vpairX.ref(rect.bx, rect.ex),
	     "prev_pairX - &vpair.ref(%d,%d)=%d",
	     rect.bx, rect.ex,
	     (prev_pairX - &vpairX.ref(rect.bx, rect.ex)));
    }
  }
  if (Task::insideType) {
    if (rect.by < rect.ey - 1) {
      Assert(pairY == &task.vpairY_ref(rect.by, rect.ey - 1),
	     "pairY - &vpair.ref(%d,%d)=%d",
	     rect.by, rect.ey - 1,
	     (pairY - &task.vpairY_ref(rect.by, rect.ey - 1)));
    }
    if (rect.by + 1 < rect.ey - 1) {
      Assert(prev_pairY == &task.vpairY_ref(rect.by + 1, rect.ey - 1),
	     "prev_pairY - &vpair.ref(%d,%d)=%d",
	     rect.by + 1, rect.ey - 1,
	     (prev_pairY - &task.vpairY_ref(rect.by + 1, rect.ey - 1)));
    }
  } else {
    if (rect.by - 1 < rect.ey) {
      Assert(pairY == &task.vpairY_ref(rect.by - 1, rect.ey),
	     "pairY - &vpair.ref(%d,%d)=%d",
	     rect.by - 1, rect.ey,
	     (pairY - &task.vpairY_ref(rect.by - 1, rect.ey)));
    }
    if (rect.by < rect.ey) {
      Assert(prev_pairY == &task.vpairY_ref(rect.by, rect.ey),
	     "prev_pairY - &vpair.ref(%d,%d)=%d",
	     rect.by + 1, rect.ey - 1,
	     (prev_pairY - &task.vpairY_ref(rect.by, rect.ey)));
    }
  }

  Assert(bn == &task.vbe_ref(rect.bx, rect.by),
	 "bn-&vbe.refB(%d,%d)=%d",
	 rect.bx, rect.by, (bn - &task.vbe_ref(rect.bx, rect.by)));
  Assert(en == &task.vbe_ref(rect.ex, rect.ey),
	 "en-&vbe.refE(%d,%d)=%d",
	 rect.ex, rect.ey, (en - &task.vbe_ref(rect.ex, rect.ey)));
  Assert(curr_sc == &task.vsc_ref(rect.by-rect.bx, rect.ex,rect.ey),
	 "curr_sc-&sc_ref(%d,%d,%d)=%d",
	 rect.by-rect.bx, rect.ex, rect.ey,
	 (curr_sc - &task.vsc_ref(rect.by-rect.bx, rect.ex, rect.ey)));

  if (rect.bx == rect.ex || rect.by == rect.ey) {
    Assert(curr_sc->isNull());
  }

  if (Task::insideType) {
    Point pt = {rect.bx + 1, rect.by + 1};
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevML);
    } else {
      Assert(!T.hasPrevML || diag_sc.isNull());
    }
    if (rect.ex <= rect.bx + 1  || rect.ey <= rect.by + 1) {
      Assert(!T.hasPrevML || diag_sc.isNull());
    }

    pt.x = rect.bx;
    pt.y = rect.by + 1;
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevIL);
      Assert(prevIL == 
	     &task.vsc_ref((rect.by + 1) - rect.bx,rect.ex,rect.ey));
    } else {
      Assert(!T.hasPrevIL);
      Assert(prevIL == NULL);
    }

    pt.x = rect.bx + 1;
    pt.y = rect.by;
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevDL);
      Assert(prevDL == 
	     &task.vsc_ref(rect.by - (rect.bx + 1), rect.ex, rect.ey));
    } else {
      Assert(!T.hasPrevDL);
      Assert(prevDL == NULL);
    }

    Rect rectDR = {{rect.bx, rect.by}, {rect.ex - 1, rect.ey}};
    if (rectDR.isNormal() && region.includes(rectDR)) {
      Assert(prevDR == 
	     &task.vsc_ref(rectDR.by - rectDR.bx, rectDR.ex, rectDR.ey));
    } else {
      Assert(prevDR == NULL || prevDR->isNull());
    }
  } else {// outside type
    Point pt = {rect.bx - 1, rect.by - 1};
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevML);
    } else {
      Assert(!T.hasPrevML || diag_sc.isNull());
    }
    //if (rect.ex <= rect.bx + 1  || rect.ey <= rect.by + 1) {
    //  Assert(diag_sc.isNull());
    //}

    pt.x = rect.bx;
    pt.y = rect.by - 1;
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevIL);
      Assert(prevIL == &task.vsc_ref(pt.y - pt.x, rect.ex, rect.ey));
    } else {
      Assert(!T.hasPrevIL);
      Assert(prevIL == NULL);
    }

    pt.x = rect.bx - 1;
    pt.y = rect.by;
    if (region.srb.includes(pt)) {
      Assert(T.hasPrevDL);
      Assert(prevDL == &task.vsc_ref(pt.y - pt.x, rect.ex, rect.ey));
    } else {
      Assert(!T.hasPrevDL);
      Assert(prevDL == NULL);
    }

    Rect rectDR = {{rect.bx, rect.by}, {rect.ex + 1, rect.ey}};
    if (rectDR.isNormal() && region.includes(rectDR)) {
      Assert(prevDR == 
	     &task.vsc_ref(rectDR.by - rectDR.bx, rectDR.ex, rectDR.ey));
    } else {
      Assert(prevDR == NULL || prevDR->isNull());
    }
  }

  switch (T.getType()) {
  case BE_IS_BE0:
    Assert(rect.b == 
	   (Task::isInsideType() ? region.srb.e0 : region.srb.b0));
    if (Task::isTriIn()) {
      Assert(rect.e == rect.b);
    } else {
      Assert(rect.e == 
	     (Task::isInsideType() ? region.sre.b0 : region.sre.e0));
    }
    Assert(prev_sc.isNull());
    Assert(diag_sc.isNull());
    break;
  case EXY_IS_EXY0:
    if (Task::isTriIn()) {
      Assert(rect.e == rect.b);
    } else {
      Assert(rect.e == 
	     (Task::isInsideType() ? region.sre.b0 : region.sre.e0));
    }
    Assert(diag_sc.isNull());
    break;
  case EXY_IS_GENERIC:
    if (Task::isTriIn()) {
      Assert(rect.bx < rect.ex || rect.by < rect.ey);
    } else {
      Assert(!(rect.e == 
	       (Task::isInsideType() ? region.sre.b0 : region.sre.e0)));
    }
    break;
  default:
    Die("bad exType=%d", T.getType());
    break;
  }
  Assert(dpRegion.isSkipRect(rect) == T.rect_is_on_skip);

  if (T.rect_is_on_skip) {
    if (Task::insideType) {
#ifdef SLR_STATE
      Assert(en->st[0] ==
	     &task.vste_ref(rect.bx, rect.by, rect.ex, rect.ey, Model::SR_st));
      Assert(bn->st[1] ==
	     &task.vstb_ref(rect.bx, rect.by, rect.ex, rect.ey, Model::SL_st));
#else
      Assert(en->st[0] ==
	     &task.vste_ref(rect.bx, rect.by, rect.ex, rect.ey));
      Assert(bn->st[1] ==
	     &task.vstb_ref(rect.bx, rect.by, rect.ex, rect.ey));
#endif
    } else {// outside type
#ifdef SLR_STATE
      Assert(bn->st[0] ==
	     &task.vstb_ref(rect.bx, rect.by, rect.ex, rect.ey, Model::BF_st));
      Assert(en->st[1] == 
             &task.vste_ref(rect.bx, rect.by, rect.ex, rect.ey, Model::BF_st));
#else
      Assert(bn->st[0] ==
	     &task.vstb_ref(rect.bx, rect.by, rect.ex, rect.ey));
      Assert(en->st[1] == 
             &task.vste_ref(rect.bx, rect.by, rect.ex, rect.ey));
#endif
    }
  }

  if (Task::isSmallCYK()) {
    //if (Task::storeB()) {// scb_store is used only after DP iterations
    //  if (Task::isInsideType()) {
    //	Assert(scb_store == &vsfbwB.head(region));
    //  } else {
    //	Assert(scb_store == &vsfbwB.tail(region));
    //  }
    //}
    // needs ref method
    //if (Task::storeE()) {
    //  if (Task::isInsideType()) {
    //	Assert(sce_store == &vfbwE.tail(region));
    //  } else {
    //	Assert(sce_store == &vfbwE.head(region));
    //  }
    //}
  } else if (Task::isCYK()) {
    Assert(tau == &task.vtb_ref(rect.bx,rect.by,rect.ex,rect.ey));
    if (dpRegion.isSkipRect(rect)) {
      Assert(tau_BF == &task.vtbbf_ref(rect.bx,rect.by,rect.ex,rect.ey));
    }
  } else if (Task::isInside()) {
    Assert(sce_store == &task.vfw_ref(rect.bx,rect.by,rect.ex,rect.ey));
    Model::Iterator it;
    while (it.getNext()) {
      const State s = it.s;
      const int i_end = model.getNChild(s);
      for (int i = 0; i < i_end; i++) {
	const State s1 = model.getChild(s, i);
	Rect rect1 = model.addNEmit(rect, s);
	if (region.includes(rect1) && !(rect == rect1)) {
	  const DPScoreT prev_sc0 = getPreviousScore(s, s1);
	  const ScoreManager::SCNode& fw = 
	    task.vfw_ref(rect1.bx, rect1.by, rect1.ex, rect1.ey);
	  Assert(abs(fw[s1] - prev_sc0) <= 0.001);
	}
      }
    }
  } else if (Task::isOutside()) {
    Assert(sce_store == &vbw.ref(region, rect));
    Model::Iterator it;
    while (it.getNext()) {
      const State s = it.s;
      const int i_end = model.getNParent(s);
      for (int i = 0; i < i_end; i++) {
	const State s1 = model.getParent(s, i);
	Rect rect1 = model.subtractNEmit(rect, s1);
	if (region.includes(rect1) && !(rect == rect1)) {
	  const DPScoreT prev_sc0 = getPreviousScore(s, s1);
	  const ScoreManager::SCNode& bw = 
	    task.vbw_ref(rect1.bx,rect1.by,rect1.ex,rect1.ey);
	  Assert(abs(bw[s1] - prev_sc0) <= 0.001);
	}
      }
    }
  } else {
  
  }


  Model::Iterator it;
  while (it.getNext()) {
    State s = it.s;
    if (model.bifurcates(s)) continue;

    if (Task::insideType) {
      Rect rect1 = model.addNEmit(rect, s);
      if (region.includes(rect1)) {
	Esc0.reset(rect);
	DPScoreT esc1 = Esc0.getVal(s);
	DPScoreT esc2 = esc(s, Model::X_st);
	Assert(IsFinite(esc1) == IsFinite(esc2));
	if (IsFinite(esc1)) {
	  Assert(abs(esc1 - esc2) <= 0.001);
	}
      }
      for (int i = 0; i < model.getNChild(s); i++) {
	State s1 = model.getChild(s, i);
	Rect rect2 = model.addNEmit(rect1, s1);
	if (region.includes(rect1) && region.includes(rect2)) {
	  Tsc0.reset(rect);
	  DPScoreT tsc1 = Tsc0.getVal(s, s1);
	  DPScoreT tsc2 = tsc(s, s1);
	  Assert(IsFinite(tsc1) == IsFinite(tsc2));
	  if (IsFinite(tsc1)) {
	    Assert(abs(tsc1 - tsc2) <= 0.001);
	  }
	}
      }
    } else {
      Rect rect1 = model.addNEmit(rect, s);
      for (int i = 0; i < model.getNParent(s); i++) {
	State s1 = model.getParent(s, i);
	Rect rect2 = model.subtractNEmit(rect, s1);
	if (region.includes(rect2)) {
	  Esc0.reset(rect2);
	  DPScoreT esc1 = Esc0.getVal(s1);
	  DPScoreT esc2 = esc(s, s1);
	  Assert(IsFinite(esc1) == IsFinite(esc2));
	  if (IsFinite(esc1)) {
	    Assert(abs(esc1 - esc2) <= 0.001);
	  }
	  if (region.includes(rect1) && region.includes(rect2)) {
	    Tsc0.reset(rect2);
	    DPScoreT tsc1 = Tsc0.getVal(s1, s);
	    //DPScoreT tsc1 = scoreManager.tsc(rect2, s1, s);
	    DPScoreT tsc2 = tsc(s, s1);
	    Assert(IsFinite(tsc1) == IsFinite(tsc2));
	    if (IsFinite(tsc1)) {
	      Assert(abs(tsc1 - tsc2) <= 0.001);
	    }
	  }
	}
      }
    }
  }

  if (skipSet.isSkipRow(rect.bx)) {
    Assert(bxr == skipSize);
    Assert(bxn == skipSet.getNSkipRow(region.srb.bx0, rect.bx) - 1);

    if (Task::insideType) {
      const int bybxk = region.getBXK(rect.by);
      if (bybxk >= 0) {
	Point pt = {max(rect.bx, bybxk), rect.by};
	Assert(by->pSkipCountB == &vskip.skipCountB_ref(region, pt));
	Assert(by->pSkipShiftB == &vskip.skipShiftB_ref(region, pt));
	Assert(by->pSkipCountE == &vskip.skipCountE_ref(region, pt));
	Assert(by->pSkipShiftE == &vskip.skipShiftE_ref(region, pt));
      } else {
	Assert(by->pSkipCountB == NULL);
	Assert(by->pSkipShiftB == NULL);
	Assert(by->pSkipCountE == NULL);
	Assert(by->pSkipShiftE == NULL);
      }
    } else {//outsideType
      int bybxk = region.getBXK(rect.by);
      if (bybxk >= 0) {
	Assert(by->pSkipCountB == 
	       &task.vskip_skipCountB_ref(rect.bx,rect.by));
	Assert(by->pSkipShiftB == 
	       &task.vskip_skipShiftB_ref(rect.bx,rect.by));
      } else {
	Assert(by->pSkipCountB == NULL);
	Assert(by->pSkipShiftB == NULL);
      }
      if (rect.by != rect.ey) {
	int eybxk = region.getBXK(rect.ey);
	if (eybxk >= 0) {
	  int x = max(rect.bx, eybxk);
	  Assert(ey->pSkipCountB == 
		 (&task.vskip_skipCountB_ref(x, rect.ey) - 1));
	  Assert(ey->pSkipShiftB == 
		 (&task.vskip_skipShiftB_ref(x, rect.ey) - 1));
	} else {
	  Assert(ey->pSkipCountB == NULL);
	  Assert(ey->pSkipShiftB == NULL);
	}
      }
    }

    if (skipSet.isSkipRow(rect.bx) && skipSet.isSkipRow(rect.ex)) {
      if (Task::insideType) {
	int eybxk = region.getBXK(rect.ey);
	if (eybxk >= 0) {
	  Point pt = {max(rect.bx, eybxk), rect.ey};
	  Assert(ey->pSkipCountB == &vskip.skipCountB_ref(region, pt));
	  Assert(ey->pSkipShiftB == &vskip.skipShiftB_ref(region, pt));
	  Assert(ey->pSkipCountE == &vskip.skipCountE_ref(region, pt));
	  Assert(ey->pSkipShiftE == &vskip.skipShiftE_ref(region, pt));
	} else {
	  Assert(ey->pSkipCountB == NULL);
	  Assert(ey->pSkipShiftB == NULL);
	  Assert(ey->pSkipCountE == NULL);
	  Assert(ey->pSkipShiftE == NULL);
	}
      } else { //outsideType
	if (rect.by != rect.ey) {
	  int byexk = region.getEXK(rect.by);
	  if (byexk >= 0) {
	    int x = min(rect.ex, byexk);
	    Assert(by->pSkipCountE == 
		   (&task.vskip_skipCountE_ref(x, rect.by) + 1));
	    Assert(by->pSkipShiftE == 
		   (&task.vskip_skipShiftE_ref(x, rect.by) + 1));
	  } else {
	    Assert(by->pSkipCountE == NULL);
	    Assert(by->pSkipShiftE == NULL);
	  }
	}
	int eybxk = region.getBXK(rect.ey);
	if (eybxk >= 0) {
	  Assert(ey->pSkipCountE 
		 == &task.vskip_skipCountE_ref(rect.ex, rect.ey));
	  Assert(ey->pSkipShiftE 
		 == &task.vskip_skipShiftE_ref(rect.ex, rect.ey));
	} else {
	  Assert(ey->pSkipCountE == NULL);
	  Assert(ey->pSkipShiftE == NULL);
	}
      }
    }
  } else if (bxn_beg >= 0) {
    Assert(0 < bxr && bxr < skipSize);
  } else {
    Assert(bxr == -1);
  }
  if (skipSet.isSkipRow(rect.bx)) {
    if (skipSet.isSkipRow(rect.ex)) {
      Assert(exr == skipSize);
      Assert(exn == region.convertXK2XN(rect.ex));
    } else if (exn_beg >= 0) {
      Assert(0 < exr && exr < skipSize);
    } else {
      Assert(exr == -1);
    }
  }
#endif
}
TEMPLATE
void
CLASS::
testDPProcFinalState() const
{
#ifdef DEBUG
  const StateFlags& T = stateFlags;
  const Rect rect = getCurrRect();
  const ScoreManager::SCNode& sc = *curr_sc;
  if (Task::isCYK()) {
    Model::Iterator it;
    while (it.getNext()) {
      const State s = it.s;
      if (IsFinite(sc[s])) {
    	if (T.getType() == BE_IS_BE0) {
    	  // leftChild rightChild endState or X_st
    	  // may not be zero since score comes from 
    	  // dpProcBifurcate()
    	  //Assert((sc[s] == ZeroDPScore) 
    	  //	 || model.bifurcates(s)
    	  //	 || Model::ST_st);
    	} else if (T.getType() == EXY_IS_GENERIC) {
    	  const Rect rect1 = model.addNEmit(rect, s);
    	  Assert(region.includes(rect1));
    	  const TBNode& tbn = dpDeck.vtb.ref(region, rect);
    
    	  if (model.bifurcates(s)) {
    	    Assert(T.rect_is_on_skip);
    	  } else {
    	    Assert(tbn.valIsSet(s));
    	    const State s1 = tbn.getVal(s);
    	    Assert(model.isChild(s, s1));
    	  }

	  const Vector<TBTree::Link>& treeNodes = 
	    dpTask.traceback(rect, s);
	  Vector<State> states1(dpTask.getStates());
	  states1[0] = s;
	  const TBTree tbTree(treeNodes, states1);
	  //tbTree.print();
	  treeNodes[0]->testConsistencyR();
	  const DPScoreT score1 =
	    dpDeck.computeScoreFromTree(tbTree, states1);
	  Assert(abs(score1 - sc[s]) <= 0.1*(1.0+abs(score1)+abs(sc[s])),
		 "score1=%f, sc[%s]=%f",
		 (float)score1, model.state2str(s), (float)sc[s]);
    	}
      }
    }

    if (T.rect_is_on_skip) {
      const TBBFNode& bfn = vtbbf.ref(region, rect);
      const int areaSkip = bfn.getArea();
      const int bfType = bfn.getBFType();
      if (IsFinite(sc[Model::BF_st])) {
	if (T.getType() != BE_IS_BE0) {
	  Assert(areaSkip > 0);
	  Assert(0 <= bfType && bfType <= 2);
	} else {
	  // T.getType() == BE_IS_BE0 case is complex
	}
      } else {
	if (T.getType() != BE_IS_BE0) {
	  Assert(areaSkip == 0);
	} else {
	  // T.getType() == BE_IS_BE0 case is complex
	}
      }
    }
    if (T.rect_is_on_skip) {
#ifdef SLR_STATE
      Assert(task.vstb_ref(rect.bx,rect.by,rect.ex,rect.ey, Model::SL_st) 
	     == sc[Model::SL_st]);
      Assert(task.vste_ref(rect.bx,rect.by,rect.ex,rect.ey, Model::SR_st) 
	     == sc[Model::SR_st]);
#else
      Assert(task.vstb_ref(rect.bx,rect.by,rect.ex,rect.ey) 
	     == sc[Model::ST_st]);
      Assert(task.vste_ref(rect.bx,rect.by,rect.ex,rect.ey) 
	     == sc[Model::ST_st]);
#endif
    }
    //if (IsFinite(sc[Model::ST_st])) {
    //  Assert(task.vtb_ref(rect.bx,rect.by,rect.ex,rect.ey)
    //	     .valIsSet(Model::ST_st));
    //} else {
    //  Assert(!task.vtb_ref(rect.bx,rect.by,rect.ex,rect.ey)
    //	     .valIsSet(Model::ST_st));
    //}
  } else if (Task::isInside()) {
    // this is completely wrong
    //const DPScoreT z = dpTask.finalScore; // loglikelihood
    //const ScoreManager::SCNode& fw = vfw.ref(region, rect);
    //Model::Iterator it;
    //while (it.getNext()) {
    //  Assert((z - fw[it.s]) > -0.001);
    //}
  } else if (Task::isOutside()) {
    if (!(rect.b == rect.e)) {
      const ScoreManager::SCNode& fw = vfw.ref(region, rect);
      const ScoreManager::SCNode& bw = vbw.ref(region, rect);
      Model::Iterator it;
      DPScoreT z = NegInfDPScore;
      while (it.getNext()) {
	if (IsFinite(fw[it.s]) && IsFinite(bw[it.s])) {
	  const DPScoreT z1 = fw[it.s] + bw[it.s];
	  Assert((dpTask.parent->finalScore - z1) > -0.01);
	  scoreManager.logAdd(z, z1);
	}
      }

      if (T.rect_is_on_skip) {
#ifdef SLR_STATE
	Assert(task.vstb_ref(rect.bx,rect.by,rect.ex,rect.ey, Model::BF_st) 
	       == sc[Model::BF_st]);
	Assert(task.vste_ref(rect.bx,rect.by,rect.ex,rect.ey, Model::BF_st) 
	       == sc[Model::BF_st]);
#else
	Assert(task.vstb_ref(rect.bx,rect.by,rect.ex,rect.ey) 
	       == sc[Model::BF_st]);
	Assert(task.vste_ref(rect.bx,rect.by,rect.ex,rect.ey) 
	       == sc[Model::BF_st]);
#endif
      }
    }
    // (rect.ex-1, rect.ey-1) may not be on dpPath.
    // possibility exists for (rect.ex-1,rect.ey) etc.
    //if (dpDeck.dpAlongPath
    //	&& (rect.bx < (rect.ex - 1))
    //	&& (rect.by < (rect.ey - 1))) {
    //  int aposBX = dpDeck.dpPath.posMapX.getAlnPos(rect.bx);
    //  int aposBY = dpDeck.dpPath.posMapY.getAlnPos(rect.by);
    //  int aposEX = dpDeck.dpPath.posMapX.getAlnPos(rect.ex - 1);
    //  int aposEY = dpDeck.dpPath.posMapY.getAlnPos(rect.ey - 1);
    //  if (aposBX >= 0 
    //	  && aposBY >= 0 
    //	  && aposEX >= 0 
    //	  && aposEY >= 0) {
    //	Assert(aposBX == aposBY);
    //	Assert(aposEX == aposEY);
    //	if (dpDeck.dpPath.ct.pairs(aposBX, aposEX)) {
    //	  //Assert((z - dpTask.parent->finalScore) > -0.01);
    //	  const float& z2 = fw[Model::MP_st] + bw[Model::MP_st];
    //	  Assert(abs(z2 - dpTask.parent->finalScore) < 0.01);
    //	}
    //  }
    //}
  }
#endif
}
TEMPLATE
void
CLASS::
testDPProcBifurcateInitialState() const
{
#ifdef DEBUG
  const Rect rect = getCurrRect();
  Assert(dpRegion.isSkipRect(rect));
  if (Task::isCYK()) {
    Assert(tau_BF == &vtbbf.ref(region, rect));
  }
#endif
}
TEMPLATE
void
CLASS::
testDPProcBifurcateFinalState() const
{
#ifdef DEBUG
  const Rect rect = getCurrRect();
  const ScoreManager::SCNode& sc = *curr_sc;
  if (Task::isCYK()) {
    if (IsFinite(sc[Model::BF_st])) {
      const TBBFNode& nd = vtbbf.ref(region, rect);
      const int bfType1 = nd.getBFType();
      const int areaSkip1 = nd.getArea();
      Assert(areaSkip1 > 0, "bfType1=%d,areaSkip1=%d",
	     bfType1, areaSkip1);

      Rect rect1;
      Rect rect2;
      dpTask.getBifurcationPoint(region, rect, bfType1, areaSkip1,
				 rect1, rect2);
      Assert(!rect1.isNull() && !rect2.isNull());
      Assert(rect1.bx <= rect1.ex && rect1.by <= rect1.ey);
      Assert(rect2.bx <= rect2.ex && rect2.by <= rect2.ey);
      const ScoreManager::SCNode& sc = *curr_sc;
      const DPScoreT score1 = 
	(task.vst_rect1_ref(bfType1,rect1.bx,rect1.by,rect1.ex,rect1.ey)
	 + task.vst_rect2_ref(bfType1,rect2.bx,rect2.by,rect2.ex,rect2.ey)
	 + scoreManager.esc(rect, Model::BF_st)
	 );
      Assert(abs(sc[Model::BF_st] - score1) 
	     <= 0.1*(1.0+abs(sc[Model::BF_st])+abs(score1)),
      	     "sc[Model::BF_st]=%f,score1=%f",
      	     (float)sc[Model::BF_st], (float)score1);
    }
  }
#endif
}
TEMPLATE
//template <DPDeckPSCFG::BFType bfType>
void
CLASS::
//testDPProcBifurcateLoopInitialState() const
testDPProcBifurcateLoopInitialState(BFType bfType) const
{
#ifdef DEBUG
  const Rect rect = getCurrRect();
  bfi.reset(rect, bfType);
#endif
}
TEMPLATE
//template <typename DPDeckPSCFG::DPLocals<Task>::Forward forward,
//	  typename DPDeckPSCFG::DPLocals<Task>::L1R2 l1_r2,
//	  DPDeckPSCFG::BFType bfType,
//	  typename DPDeckPSCFG::DPLocals<Task>::MarginType marginType>
void
CLASS::
//testDPProcBifurcateLoopTransientState() const
testDPProcBifurcateLoopTransientState(Forward forward, L1R2 l1_r2,
				      BFType bfType, MarginType marginType) const
{
#ifdef DEBUG
  Assert(bfi.getNext());
  const Rect rect = getCurrRect();
  const Rect rect1 = bfi.rect1;
  const Rect rect2 = bfi.rect2;
  Assert(rect1.isNormal() && rect1.isNormal());
  if (Task::isInsideType()) {
    Assert(rect.b == rect1.b && rect.e == rect2.e);
  } else {
    switch (bfType) {
    case BF_TYPE_0:
      Assert(rect.b == rect1.b && rect.e == rect2.b);
      break;
    case BF_TYPE_1:
      Assert(rect.b == rect2.e && rect.e == rect1.e);
      break;
    case BF_TYPE_2:
      Assert((rect.b == rect1.b && rect.e == rect2.b)
	     || (rect.b == rect2.e && rect.e == rect1.e));
      break;
    default:
      Die("bad bfType=%d", bfType);
      break;
    }
  }
  Assert(dpRegion.isSkipRect(rect1));
  Assert(dpRegion.isSkipRect(rect2));
  Assert(scVSTRect1 == 
	 &task.vst_rect1_ref(bfType,
			     rect1.bx,rect1.by,rect1.ex,rect1.ey));
  Assert(scVSTRect2 ==
	 &task.vst_rect2_ref(bfType,
			     rect2.bx,rect2.by,rect2.ex,rect2.ey));
  if (rect1.b == rect1.e || rect2.b == rect2.e) {
    Assert((!IsFinite(*scVSTRect1))
	   || (!IsFinite(*scVSTRect2)));
  }
  // check skipCount using skipSet.getNSkipY
  if (skipRowCount >= 2) {
    if (marginType & MARGIN_L) {
      Assert(*pSkipShiftL >= 0);
    }
    if (marginType & MARGIN_R) {
      Assert(*pSkipShiftR >= 0);
    }
  }
#endif
}
TEMPLATE
//template <DPDeckPSCFG::BFType bfType>
void
CLASS::
//testDPProcBifurcateLoopFinalState() const
testDPProcBifurcateLoopFinalState(BFType bfType) const
{
#ifdef DEBUG
  Assert(!bfi.getNext());
  const Rect rect = getCurrRect();
  if (Task::isCYK() && (best_split_ptr_plus_1 != NULL)) {
    Assert(IsFinite(best_score1));
    Rect rect1;
    Rect rect2;
    int best_split_offset1 = abs(best_split_ptr_plus_1 - scVSTRect20);
    //Point mpt = 
    dpTask.getBifurcationPoint(region, rect, 
			       bfType, best_split_offset1,
			       rect1, rect2);
    DPScoreT sc1 = 
      task.vst_rect1_ref(bfType,rect1.bx,rect1.by,rect1.ex,rect1.ey);
    DPScoreT sc2 =
      task.vst_rect2_ref(bfType,rect2.bx,rect2.by,rect2.ex,rect2.ey);
    Assert(abs(best_score1 - (sc1 + sc2)) <= 0.01);
  }
#endif
}

#undef TEMPLATE
#undef CLASS
#endif
