/*
 * DPDeckPSCFGDPRegionIterators.hpp
 *
 */
#ifndef DP_DECK_PSCFG_DP_REGION_ITERATORS_HPP
#define DP_DECK_PSCFG_DP_REGION_ITERATORS_HPP
#include "DPDeckPSCFGDPRegion.hpp"

template <bool forward0>
class DPDeckPSCFG::DPRegion::Iterator {
public:
  int regionNum;
  Rect rect;

  Iterator(const DPRegion& dpRegion);
  ~Iterator();
  void clear();
  void reset();
  bool getNext();

private:
  const DPRegion& dpRegion;
  int idx;
  int idx_lim;
  Vector< Region::Iterator<forward0>* > vit;

  Iterator();
  Iterator(const Iterator& it);
  Iterator& operator=(const Iterator& it);
};

template <bool forward0>
class DPDeckPSCFG::DPRegion::SkipRowIterator {
public:
  int x;
  int y_beg;
  int y_last;
  int count;

  SkipRowIterator(const DPRegion& dpRegion);
  ~SkipRowIterator();
  void reset(const Rect& rect);
  bool getNext();

private:
  Rect bbox;
  int x_beg;
  int x_last;
  int i;
    
  SkipIterator();
  SkipIterator(const SkipIterator& it);
  SkipIterator& operator=(const SkipIterator& it);
};

template <bool inside0>
class DPDeckPSCFG::DPRegion::Region::SkipIterator {
public:
  Rect rect1;
  Rect rect2;

  SkipIterator(const DPRegion& dpRegion, const Region& region);
  ~SkipIterator();
  void reset(const Region& region,
	     const Rect& rect0, const int& rectType0);
  bool getNext();
private:
  const DPRegion& dpRegion;
  Region::SkipIterator<inside0> sit;
  int rectType;
  Rect rect;
  Rect rectm;

  SkipIterator();
  SkipIterator(const SkipIterator& it);
  SkipIterator& operator=(const SkipIterator& it);
};

#endif
